# maximum likelihood inference of age at maturity

read.table("mature_age.txt")->mature_age
round(mature_age,3)

nlike.glm <- function(theta,data){
	c <- theta[1]; age0 <- theta[2]
	n <- dim(data)[1]
	x <- data[,1]; y <- data[,2]
	p <- 1/(1+exp(-4*c*(x-age0)))
	loglike <- sum(dbinom(y,size=1,prob=p,log=T))
	return(-loglike)
	}

theta0 <- c(0,0)
theta_est <- optim(theta0,nlike.glm,data=mature_age,hessian=T)
theta_est
est <- theta_est$par
se <- sqrt(diag(solve(theta_est$hessian)))
mle <- data.frame(estimate=est,standard_error=se,row.names=c("c","age0"))
round(mle,4)

plot(mature_age)
curve( 1/(1+exp(-4*est[1]*(x-est[2]))),xlim=c(0,50),col="red",add=T)

