########   transition probability of Kimura80 model   ########
trans.Kimura80 <- function(t,alpha,beta){
	trans.Kimura80 <- 
		matrix(1/4-1/4*exp(-4*beta*t),nrow=4,ncol=4,
			dimnames=list(c("T","C","A","G"),c("T","C","A","G")))
	diag(trans.Kimura80)<- 1/4+1/4*exp(-4*beta*t)+1/2*exp(-2*(alpha+beta)*t)
	trans.Kimura80[1,2] <- 1/4+1/4*exp(-4*beta*t)-1/2*exp(-2*(alpha+beta)*t)
	trans.Kimura80[2,1] <- trans.Kimura80[3,4] <- trans.Kimura80[4,3] <- trans.Kimura80[1,2]
	trans.Kimura80
	}

########   negative log likelihood of pair of sequences   ########
########                under Kimura80 model              ########
Kimura80.nLL <- 
function(theta,data){
	t <- theta[1]; alpha <- theta[2]; beta <- 1
	nuc12 <- dimnames(data)
	pequi <- rep(1/4,4)
	prob.pair <- diag(pequi)%*%trans.Kimura80(t,alpha,beta)
	dimnames(prob.pair) <- list(c("T","C","A","G"),c("T","C","A","G"))
	Kimura80.nLL <- 0
	for (i in 1:dim(data)[1])
	for (j in 1:dim(data)[2]){
		Kimura80.nLL <- 
			Kimura80.nLL -
			data[nuc12[[1]][i],nuc12[[2]][j]] *
			log(prob.pair[nuc12[[1]][i],nuc12[[2]][j]])
		}
	Kimura80.nLL
	}


########   Analysis of mt genomes from human and chimpanzee     ########
####  reading sequence pair   ########
scan("mtCDNA_human.nuc",what="")->human
scan("mtCDNA_chimp.nuc",what="")->chimp
human <- strsplit(human,split="")
human <- unlist(human)
chimp <- strsplit(chimp,split="")
chimp <- unlist(chimp)
cross_HC <- table(human,chimp)
cross_HC

init <- c(0.1,1)
Kimura80.ML <- optim(init,Kimura80.nLL,data=cross_HC,hessian=T)
Kimura80.ML_est <- Kimura80.ML$par
Kimura80.ML_se <- sqrt(diag(solve(Kimura80.ML$hessian)))
result <- cbind(Kimura80.ML_est,Kimura80.ML_se)
dimnames(result) <- list(c("t","alpha"),c("estimate","standard error"))
round(result,4)
